#include <iostream>
#include <fstream>
#include <sstream>
#include <map>
#include <vector>

#define ITEM 1682

using namespace std;

typedef map< short, short > MAP_S;
typedef map< short, MAP_S > MAP_SS; // item, (user, rate)

float DEV[ITEM+1][ITEM+1][2]; // [0]:DEV [1]:weight

// ****************
// baseファイル入力
// ****************
MAP_SS input(char FILE_NO){
  MAP_SS OData;
  short user, item, rate;
  int date;

  stringstream ss;
  ss << "/home/shared/dataset/data" << FILE_NO << ".txt";
  ifstream fin( ss.str().c_str() );
  //ifstream fin( "./MovieLens/test.u.data" );
  if( !fin ){
    cout << "base file open error" << endl;
    exit(1);
  }

  while( fin >> user >> item >> rate >> date ){
    if(OData.find(item) == OData.end()){
      MAP_S user_rate;
      user_rate.insert( make_pair(user, rate) );
      OData.insert( make_pair( item, user_rate ));
    } else {
      OData[item].insert( make_pair(user, rate) );
    }
  }

  fin.close();

  return OData;
}

// ********
// 平均偏差
// ********
void calc_dev(short i, short j, MAP_S im, MAP_S jm){
  int r=0, n=0;

  MAP_S::iterator itr_i, itr_j;

  /* デバッグ
  cout << "map i" << endl;
  for(itr_i = i.begin(); itr_i !=i.end(); itr_i++){
    cout << (*itr_i).first << " " << (*itr_i).second << endl;
  }
  cout << "map j" << endl;
  for(itr_j = j.begin(); itr_j !=j.end(); itr_j++){
    cout << (*itr_j).first << " " << (*itr_j).second << endl;
  }
  */

  for(itr_i = im.begin(), itr_j = jm.begin(); itr_i !=  im.end() && itr_j != jm.end(); ){
    if( (*itr_i).first == (*itr_j).first ){
      r += (*itr_i).second - (*itr_j).second;
      n++;
      itr_i++; itr_j++;
    } else if( (*itr_i).first < (*itr_j).first ){
      itr_i++;
    } else {
      itr_j++;
    }
  }

  if(n != 0){
    DEV[i][j][0] = r*1.0/n;
    DEV[i][j][1] = n+1;
  } else {
    DEV[i][j][0] = 0.0;
    DEV[i][j][1] = 1;
  }
  DEV[j][i][0] = -DEV[i][j][0];
  DEV[j][i][1] = DEV[i][j][1];

  return;
}

void make_dev(MAP_SS OData){
  MAP_SS::iterator itr_i, itr_j;
  int cnt = 0;
 
  for(short i=1; i<=ITEM; i++){
    for(short j=i+1; j<=ITEM; j++){
      /* 動作確認用 */
      cnt++; if(cnt%10000 == 0) cout << cnt/10000 << "/141" << endl;

      itr_i = OData.find(i);
      itr_j = OData.find(j);
      if( itr_i != OData.end() && itr_j != OData.end() ){
	calc_dev( i, j, (*itr_i).second, (*itr_j).second );
      }
    }
  }

  return;
}

vector< pair<short, short> > user_eval(short u, MAP_SS OData){
  vector< pair<short, short> > v;
  MAP_SS::iterator itr;

  for(itr = OData.begin(); itr != OData.end(); itr++){
    if( (*itr).second.find(u) != (*itr).second.end() )
      v.push_back( make_pair((*itr).first,(*itr).second[u]) );
  }

  /* デバッグ
  cout << "user_eval : " << u << endl;
  vector< pair<short, short> >::iterator it;
  for(it = v.begin(); it != v.end(); it++)
    cout << (*it).first << "," << (*it).second << endl;
  */

  return v;
}

float recommend(short u, short i, MAP_SS OData){
  MAP_SS::iterator itr;
  vector< pair<short, short> > v;
  vector< pair<short, short> >::iterator it;

  v = user_eval(u, OData);

  /*
  for(it = v.begin(); it != v.end(); it++){
    cout << (*it).first << "," << (*it).second << " ";
  }
  cout << endl;
  */

  float total = 0.0, w_total = 0;

  for(it = v.begin(); it != v.end(); it++){
    total += ( (*it).second + DEV[i][(*it).first][0] ) * DEV[i][(*it).first][1];
    w_total += DEV[i][(*it).first][1];
  }

  if(w_total != 0){
    return total/w_total;
  } else {
    return 0.0;
  }
}

// ******
// メイン
// ******
int main(char argc, char *argv[]){
  MAP_SS OData = input( *argv[1] );

  cout << "データ入力完了" << endl;
  /* デバッグ
  MAP_SS::iterator itr_ss;
  MAP_S::iterator itr_s;
  cout << "OData" << endl;
  for(itr_ss = OData.begin(); itr_ss != OData.end(); itr_ss++){
    cout << "item " <<(*itr_ss).first << endl;
    for(itr_s = (*itr_ss).second.begin(); itr_s != (*itr_ss).second.end(); itr_s++){
      cout << "(" << (*itr_s).first << ", " << (*itr_s).second << ")" << endl;
    }
  }
  */

  make_dev( OData );

  cout << "DEV完了" << endl;
  /* デバッグ
  for(short i=1; i<=ITEM; i++){
    for(short j=1; j<=ITEM; j++){
      if(i==j) cout << "0" << "\t";
      else cout << DEV[i][j][0] << "," << DEV[i][j][1] << "\t";
    }
    cout << endl;
  }
  */
  /* DEVを念のためファイル出力
  stringstream ss_dev;
  ss_dev << "u" << *argv[1] << ".out.ws.dev";
  ofstream tfout( ss_dev.str().c_str() );
  for(int i=1; i<=ITEM; i++){
    for(int j=1; j<=ITEM; j++){
      tfout << DEV[i][j] << " ";
    }
    tfout << endl;
  }
  tfout.close();
  */

  short user, item, rate;
  int date;

  /* testファイル入力 */
  stringstream ss_t;
  ss_t << "/home/shared/dataset/test" << *argv[1] << ".txt";
  ifstream fin( ss_t.str().c_str() );
  //ifstream fin( "./MovieLens/test.u.test" );
  if( !fin ){
    cout << "test file open error" << endl;
    return 1;
  }

  /* ファイル出力 */
  stringstream ss_o;
  ss_o << "data" << *argv[1] << ".out.ws.g1";
  ofstream fout( ss_o.str().c_str() );
  //ofstream fout( "test.u.out.ws" );
  int fn = 0;
  while( fin >> user >> item >> rate >> date ){
    fn++; if(fn%100 == 0) cout << fn << "/20000" << endl; /* 動作確認用 */
    fout << user << "\t" << item << "\t" << recommend(user, item, OData) << endl;
  }

  OData.clear();
  fin.close();
  fout.close();

  return 0;
}
